#include <HardwareSerial.h>
#include "SoftwareSerial.h"

SoftwareSerial mySerial(18,19); // RX, TX

#include "Arduino.h"
#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define SCREEN_WIDTH 128
#define SCREEN_HEIGHT 64

#define OLED_RESET -1
Adafruit_SSD1306 OLED(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);

TaskHandle_t Task0;
TaskHandle_t Task1;

#define RXD2 16
#define TXD2 17

unsigned int pm1 = 0;
unsigned int pm2_5 = 0;
unsigned int pm10 = 0;
int i;
const int sw = 4;
int oled_mode = 0;
int t = 0;

void loop_T0(void * parameter) {
  for (;;) {
    /*
      if (oled_mode == 1 && t > 10) {
        for (i=15; i>=0; i--) {
          OLED.clearDisplay(); // ลบภาพในหน้าจอทั้งหมด
          OLED.setTextColor(WHITE, BLACK);  //กำหนดข้อความสีขาว ฉากหลังสีดำ
          OLED.setCursor(30, 0); // กำหนดตำแหน่ง x,y ที่จะแสดงผล
          OLED.setTextSize(2); // กำหนดขนาดตัวอักษร
          OLED.println("WAIT"); // แสดงผลข้อความ ALL
          OLED.setTextSize(4);
          OLED.setTextColor(WHITE, BLACK);
          if (i > 9) {
            OLED.setCursor(30, 32);
          }
          else {
            OLED.setCursor(50, 32);
          }
          OLED.println(i, DEC);
          OLED.setCursor(85,40);
          OLED.setTextSize(1);
          OLED.println("sec");
          OLED.display(); // สั่งให้จอแสดงผล
          delay(1000);
        }
        for (i=20; i>=0; i--) {
          OLED.clearDisplay(); // ลบภาพในหน้าจอทั้งหมด
          OLED.setTextColor(WHITE, BLACK);  //กำหนดข้อความสีขาว ฉากหลังสีดำ
          OLED.setCursor(30, 0); // กำหนดตำแหน่ง x,y ที่จะแสดงผล
          OLED.setTextSize(2); // กำหนดขนาดตัวอักษร
          OLED.println("WALK"); // แสดงผลข้อความ ALL
          OLED.setTextSize(4);
          OLED.setTextColor(WHITE, BLACK);
          if (i > 9) {
            OLED.setCursor(30, 32);
          }
          else {
            OLED.setCursor(50, 32);
          }
          OLED.println(i, DEC);
          OLED.setCursor(85,40);
          OLED.setTextSize(1);
          OLED.println("sec");
          OLED.display(); // สั่งให้จอแสดงผล
          delay(1000);
        }
        oled_mode = 0;
        t = 0;
      }
     
      OLED.clearDisplay(); // ลบภาพในหน้าจอทั้งหมด
      OLED.setTextColor(WHITE, BLACK);  //กำหนดข้อความสีขาว ฉากหลังสีดำ
      OLED.setCursor(25, 0); // กำหนดตำแหน่ง x,y ที่จะแสดงผล
      OLED.setTextSize(2); // กำหนดขนาดตัวอักษร
      OLED.println("PM 2.5"); // แสดงผลข้อความ ALL
      OLED.setTextSize(4);
      OLED.setTextColor(WHITE, BLACK);
      if (pm2_5 > 9) {
        OLED.setCursor(30, 32);
      }
      else {
        OLED.setCursor(50, 32);
      }
      OLED.println(pm2_5, DEC);
      OLED.setCursor(85,40);
      OLED.setTextSize(1);
      OLED.println("ug/m3");
      OLED.display(); // สั่งให้จอแสดงผล
      delay(1000);  
      t++; 
      */
  }
}


void loop_T1(void * parameter) { 
  for (;;) {
    Serial.println(oled_mode);
    if (digitalRead(sw) == HIGH) {
      oled_mode = 1;
    }
  }
}


int var = 0;
void setup() {
  // put your setup code here, to run once:
  pinMode(sw, INPUT);
  Serial.begin(9600);
  while (!Serial) ;
    mySerial.begin(9600);
  if (!OLED.begin(SSD1306_SWITCHCAPVCC, 0x3C)) { // สั่งให้จอ OLED เริ่มทำงานที่ Address 0x3C
    Serial.println("SSD1306 allocation failed");
  } else {
    Serial.println("ArdinoAll OLED Start Work !!!");
  }  
  Serial2.begin(9600, SERIAL_8N1, RXD2, TXD2);
  

  /*
  xTaskCreatePinnedToCore(
      loop_T0, 
      "Task0", 
      1000, 
      NULL, 
      0, 
      &Task0, 
      0); 
  */
  
  xTaskCreatePinnedToCore(
      loop_T1, 
      "Task1", 
      1000, 
      NULL, 
      0, 
      &Task1,
      1); 
  
}

void loop() {
  int index = 0;
  char value;
  char previousValue;
   
  while (mySerial.available()) {
  value = mySerial.read();
  if ((index == 0 && value != 0x42) || (index == 1 && value != 0x4d)){
  //Serial.println("Cannot find the data header.");
  break;
  }
   
  if (index == 4 || index == 6 || index == 8 || index == 10 || index == 12 || index == 14) {
  previousValue = value;
  }
  else if (index == 5) {
    pm1 = 256 * previousValue + value;
  }
  else if (index == 7) {
    pm2_5 = 256 * previousValue + value;
    Serial2.write(pm2_5);
  }
  else if (index == 9) {
    pm10 = 256 * previousValue + value;
  } else if (index > 15) {
  break;
  }
  index++;
  }
  while(mySerial.available()) mySerial.read();
  //Serial.println(" }");
  
      
      
  ///////////////////////////////
  
      if (oled_mode == 1 && t > 10) {
        for (i=15; i>=0; i--) {
          OLED.clearDisplay(); // ลบภาพในหน้าจอทั้งหมด
          OLED.setTextColor(WHITE, BLACK);  //กำหนดข้อความสีขาว ฉากหลังสีดำ
          OLED.setCursor(30, 0); // กำหนดตำแหน่ง x,y ที่จะแสดงผล
          OLED.setTextSize(2); // กำหนดขนาดตัวอักษร
          OLED.println("WAIT"); // แสดงผลข้อความ ALL
          OLED.setTextSize(4);
          OLED.setTextColor(WHITE, BLACK);
          if (i > 9) {
            OLED.setCursor(30, 32);
          }
          else {
            OLED.setCursor(50, 32);
          }
          OLED.println(i, DEC);
          OLED.setCursor(85,40);
          OLED.setTextSize(1);
          OLED.println("sec");
          OLED.display(); // สั่งให้จอแสดงผล
          delay(1000);
        }
        for (i=20; i>=0; i--) {
          OLED.clearDisplay(); // ลบภาพในหน้าจอทั้งหมด
          OLED.setTextColor(WHITE, BLACK);  //กำหนดข้อความสีขาว ฉากหลังสีดำ
          OLED.setCursor(30, 0); // กำหนดตำแหน่ง x,y ที่จะแสดงผล
          OLED.setTextSize(2); // กำหนดขนาดตัวอักษร
          OLED.println("WALK"); // แสดงผลข้อความ ALL
          OLED.setTextSize(4);
          OLED.setTextColor(WHITE, BLACK);
          if (i > 9) {
            OLED.setCursor(30, 32);
          }
          else {
            OLED.setCursor(50, 32);
          }
          OLED.println(i, DEC);
          OLED.setCursor(85,40);
          OLED.setTextSize(1);
          OLED.println("sec");
          OLED.display(); // สั่งให้จอแสดงผล
          delay(1000);
        }
        oled_mode = 0;
        t = 0;
      }
     
      OLED.clearDisplay(); // ลบภาพในหน้าจอทั้งหมด
      OLED.setTextColor(WHITE, BLACK);  //กำหนดข้อความสีขาว ฉากหลังสีดำ
      OLED.setCursor(25, 0); // กำหนดตำแหน่ง x,y ที่จะแสดงผล
      OLED.setTextSize(2); // กำหนดขนาดตัวอักษร
      OLED.println("PM 2.5"); // แสดงผลข้อความ ALL
      OLED.setTextSize(4);
      OLED.setTextColor(WHITE, BLACK);
      if (pm2_5 > 99) {
        OLED.setCursor(10, 32);
      }
      else if (pm2_5 > 9) {
        OLED.setCursor(30, 32);
      }
      else {
        OLED.setCursor(50, 32);
      }
      OLED.println(pm2_5, DEC);
      OLED.setCursor(85,40);
      OLED.setTextSize(1);
      OLED.println("ug/m3");
      OLED.display(); // สั่งให้จอแสดงผล
      delay(1000);  
      t++;   
  
  delay(1000);
}
